#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <string.h>
#ifdef __DJGPP__
#include <unistd.h>
#endif


#include "can.h"

#define swap(data) (((data << 8) & 0xFF00) | ((data >> 8) & 0x00FF))

#define EXTENDED 0

unsigned char testmsg0[]={"msg0000!"};
unsigned char testmsg1[]={"msg1111!"};
unsigned char testmsg2[]={"msg2222!"};
unsigned char testmsg3[]={"msg3333!"};
unsigned char testmsg4[]={"msg4444!"};
unsigned char testmsg5[]={"msg5555!"};
unsigned char testmsg6[]={"12345678"};
unsigned char start[8];

int  isaVect[]={0,3,4,5,7,9,10,11,12,14,15};

//#define canWrite(a,b,c,d) canWriteEx(a,b,c,d)


void main
    (
    int           argc,
    char*         argv[]
    )
    {
    int           l;
    int           busy=1;
    unsigned char data[8];
    int           length;
    int           id;
    long          ex_id;
    int           ok;
    int           msgStatus;
    int           status;
    int           net;
    int           testdata,testdata1;

    int myIrq  = 0;
    int myAddr = 0x1e0;

    printf("Starting...\n");

    if (argc > 1)
	{
	myIrq=atoi(argv[1]);
        ok = 0;
        for (l=0;l<11;l++)
            {
            if (myIrq == isaVect[l])
                ok=1;
            }
	if (ok == 0)
            {
            printf("Illegal IRQ used...\n");
            exit(1);
            }
	printf("Used Irq %d\n",myIrq);
	}

    if (argc > 2)
        {
        myAddr=atoi(argv[3]);
        printf("Used IO Base Addr %04x\n",myAddr);
	}

    status = canHwInit(myAddr);
    if(myIrq == 0)
        {
        status = canHwReset();
	}
    else
        {
        status = canEnableIrq(myIrq);
        sleep(5);
        }
    status = canInit(0,2);
#if EXTENDED == 1
    status = canInitEx(1,0x001c);
    status = canSetAcceptanceEx(1,0,0x1E00000F,0x10000001);
#endif
    printf("Enabling Id's...\n");
    for(l=0x000;l<0x800;l++)
	status = canEnableId(0,l);
    // Make canOpem Modules happy
    status = canEnableId(1,0);
    start[0]=1;start[1]=0;
    printf("Sending start message...\n");
    status = canWrite(0,0,2,&start[0]);
#if EXTENDED == 1
     status = canWrite(0,0,2,&start[0]);
#endif
    testdata1 = swap(testdata);
    status    = canWrite(0,0x201,2,(unsigned char *)&testdata1);
    testdata++;
    do
	{
#if EXTENDED == 1
	msgStatus = canReadEx(&net,&ex_id,&length,&data[0]);
	id = ex_id & 0x7ff;
#endif
#if EXTENDED == 0
	msgStatus = canRead(&net,&id,&length,&data[0]);
#endif
#if 0
	if (msgStatus != -1)
	    printf("Msg :0x%02X\n",msgStatus);
#endif
	if(msgStatus == CAN_HM_BCAN)
	    {
	    printf("Can Rx Frame %04X %2X ",id,length);
	    if (length < 0x10 )
		{
		if (length != 0)
		    {
		    for (l=0;l<length;l++)
			printf("%02X ",(unsigned char) (data[l]));
		    }
		printf("\n");
		}
	    else
		{
		printf("RTR\n");
		}
	    if (id == 2)
		{
		status = canWrite(0,id+1,8,&testmsg0[0]);
		status = canWrite(0,id+2,8,&testmsg1[0]);
		status = canWrite(0,id+3,8,&testmsg2[0]);
		status = canWrite(0,id+4,8,&testmsg3[0]);
		status = canWrite(0,id+5,8,&testmsg4[0]);
		status = canWrite(0,id+6,8,&testmsg5[0]);
		status = canWrite(0,id+7,8,&testmsg6[0]);
		testmsg0[7]++;if(testmsg0[7] > 'z') testmsg0[7]='!';
		testmsg1[7]++;if(testmsg1[7] > 'z') testmsg1[7]='!';
		testmsg2[7]++;if(testmsg2[7] > 'z') testmsg2[7]='!';
		testmsg3[7]++;if(testmsg3[7] > 'z') testmsg3[7]='!';
		testmsg4[7]++;if(testmsg4[7] > 'z') testmsg4[7]='!';
		testmsg5[7]++;if(testmsg5[7] > 'z') testmsg5[7]='!';
		}
	    }
#if EXTENDED == 1
	if(msgStatus == CAN_HM_EX_BCAN)
	    {
	    printf("Can RxExtFrame %08lX %2X ",ex_id,length);
	    if (length < 0x10 )
		{
		if (length != 0)
		    {
		    for (l=0;l<length;l++)
			printf("%02X ",(unsigned char) (data[l]));
		    }
		printf("\n");
		}
	     else
		{
		printf("RTR\n");
		}
	    if (ex_id == 2)
		{
		puts("WriteEx !!!");
		status = canWriteEx(0,0x11223344,8,&testmsg0[0]);
		status = canWriteEx(0,0x12345670,8,&testmsg1[0]);
		status = canWriteEx(0,0x11112222,8,&testmsg2[0]);
		}
	    }
#endif
        if(msgStatus == CAN_HM_TXDONE)
            {
            printf("Can Tx done  %04X %2X\n",id,length);
            }
        if(msgStatus == CAN_HM_ERROR)
            {
	    printf("Can Error    %4X\n",data[0]*256+data[1]);
            }
	if(msgStatus == CAN_HM_TXTOUT)
            {
	    printf("Can Tx Tout  %04X %2X\n",id,length);
            }
	if (kbhit())
            {
            status = getch();
            if (status == 0x20)
                {
		testdata1 = swap(testdata);
                status = canWrite(0,0x201,2,(unsigned char *)&testdata1);
		testdata++;
                }
	    else
                {
		busy=0;
                }
            }
        }
    while (busy);
    if (myIrq != 0)
    status = canDisableIrq();
    exit(0);
    }
